"use strict";

var _dogmalang = require("dogmalang");

const HttpReq = _dogmalang.dogma.use(require("./HttpReq"));const ClientInfo = _dogmalang.dogma.use(require("./ClientInfo"));const HttpInfo = _dogmalang.dogma.use(require("./HttpInfo"));
const $ConReq = class ConReq extends HttpReq {
  constructor(path, rsc, conReq) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpected("path", path, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rsc", rsc, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("conReq", conReq, null);{
      super(rsc, ClientInfo({ ["addr"]: conReq.client.remoteAddress, ["port"]: conReq.client.remotePort, ["browser"]: _dogmalang.dogma.getItem(conReq.headers, "user-agent") }), HttpInfo({ ["scheme"]: "http", ["version"]: conReq.httpVersion, ["method"]: conReq.method }));_dogmalang.dogma.update(_dogmalang.dogma.update(this, { name: "path", visib: ".", assign: "=", value: conReq.url }), { name: "conReq", visib: ":", assign: ":=", value: conReq });_dogmalang.dogma.update(this, { name: "params", visib: ".", assign: ":=", value: getParams(path, rsc) });for (let [name, val] of Object.entries(conReq.headers)) {
        {
          this.headers.set(name, val);
        }
      }for (let [name, val] of Object.entries(conReq.cookies)) {
        {
          this.cookies.set(name, val);
        }
      }
    }
  }
};
const ConReq = new Proxy($ConReq, { apply(receiver, self, args) {
    return new $ConReq(...args);
  } });module.exports = exports = ConReq;
function getParams(path, rsc) {
  let params = {}; /* istanbul ignore next */_dogmalang.dogma.paramExpected("path", path, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rsc", rsc, null);{
    for (let i = 0, pp = _dogmalang.dogma.getSlice(RegExp(rsc.route).exec(path), 1, -1); i < (0, _dogmalang.len)(pp); i += 1) {
      const param = _dogmalang.dogma.getItem(rsc.params, i);const oVal = _dogmalang.dogma.getItem(pp, i);let val = _dogmalang.dogma.getItem(pp, i);if (param.type == "bool") {
        {
          const _ = val;switch (_) {case "true":
              {
                val = true;
              }; /* istanbul ignore next */break;case "false":
              {
                val = false;
              }; /* istanbul ignore next */break;default:
              {
                _dogmalang.dogma.raise("invalid param: %s. Expected: bool. Received: %s.", param.name, oVal);
              }}
        }
      } else if (param.type == "num") {
        if (Number.isNaN(val = (0, _dogmalang.num)(val))) {
          _dogmalang.dogma.raise("invalid param: %s. Expected: num. Received: %s.", param.name, oVal);
        }
      } else {
        val = decodeURI(val);
      }_dogmalang.dogma.setItem("=", params, param.name, val);
    }
  }return params;
}
ConReq.prototype.content = function () {
  {
    return this._conReq.body;
  }
};
ConReq.prototype.c = function () {
  {
    return this.content();
  }
};