"use strict";

var _dogmalang = require("dogmalang");

const $Cookies = class Cookies {
  constructor() {
    {
      _dogmalang.dogma.update(this, { name: "items", visib: ":", assign: ":=", value: {} });
    }
  }
};
const Cookies = new Proxy($Cookies, { apply(receiver, self, args) {
    return new $Cookies(...args);
  } });module.exports = exports = Cookies;
Cookies.prototype.get = function (name) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    return _dogmalang.dogma.getItem(this._items, name) ? _dogmalang.dogma.getItem(this._items, name).value : null;
  }
};
Cookies.prototype.set = function (name, value, opts = {}) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpected("value", value, _dogmalang.any); /* istanbul ignore next */_dogmalang.dogma.paramExpectedToBe("opts", opts, _dogmalang.map);{
    _dogmalang.dogma.setItem("=", this._items, name, { ["value"]: value, ["opts"]: opts });
  }return this;
};
Cookies.prototype.remove = function (name) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    (0, _dogmalang.remove)(name, this._items);
  }return this;
};