"use strict";

var _dogmalang = require("dogmalang");

const $Headers = class Headers {
  constructor() {
    {
      _dogmalang.dogma.update(this, { name: "items", visib: ":", assign: ":=", value: {} });
    }
  }
};
const Headers = new Proxy($Headers, { apply(receiver, self, args) {
    return new $Headers(...args);
  } });module.exports = exports = Headers;
Headers.prototype.get = function (name) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    return _dogmalang.dogma.getItem(this._items, name.toLowerCase());
  }
};
Headers.prototype.set = function (name, val) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpected("val", val, _dogmalang.any);{
    _dogmalang.dogma.setItem("=", this._items, name.toLowerCase(), val);
  }return this;
};
Headers.prototype.remove = function (name) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    (0, _dogmalang.remove)(name.toLowerCase(), this._items);
  }return this;
};