"use strict";

var _dogmalang = require("dogmalang");

const HttpMsg = _dogmalang.dogma.use(require("./HttpMsg"));const ClientInfo = _dogmalang.dogma.use(require("./ClientInfo"));const HttpInfo = _dogmalang.dogma.use(require("./HttpInfo"));
const $HttpReq = class HttpReq extends HttpMsg {
  constructor(rsc, client, http) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpected("client", client, ClientInfo); /* istanbul ignore next */_dogmalang.dogma.paramExpected("http", http, HttpInfo);super(rsc);Object.defineProperty(this, "client", { value: client, enum: true, writable: false });Object.defineProperty(this, "http", { value: http, enum: true, writable: false });{}
  }
};
const HttpReq = new Proxy($HttpReq, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'HttpReq' is abstract.";
  } });module.exports = exports = HttpReq;
/* istanbul ignore next */HttpReq.prototype.content = function () {
  (0, _dogmalang.abstract)();
};
HttpReq.prototype.c = function () {
  {
    return this.content();
  }
};
HttpReq.prototype.contentType = function () {
  {
    return this.headers.get("Content-Type");
  }
};
HttpReq.prototype.cType = function () {
  {
    return this.contentType();
  }
};