"use strict";

var _dogmalang = require("dogmalang");

const $HttpResource = class HttpResource {
  constructor() {
    this._constructor(...arguments);
  }_constructor(props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("props", props, { status: { type: _dogmalang.num, mandatory: false }, contentType: { type: _dogmalang.text, mandatory: false } }, false);{
      _dogmalang.dogma.update(this, { name: "dfltStatus", visib: ":", assign: "=", value: props != null ? props.status : null }, { name: "dfltContentType", visib: ":", assign: "=", value: props != null ? props.contentType : null });
    }
  }
};
const HttpResource = new Proxy($HttpResource, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'HttpResource' is abstract.";
  } });module.exports = exports = HttpResource;
Object.defineProperty(HttpResource.prototype, "path", { enum: true, get: function () {
    {
      return this.parent && this.parent.name != "/" ? this.parent.path + "/" + this.name : (this.name == "/" ? "" : "/") + this.name;
    }
  } });
Object.defineProperty(HttpResource.prototype, "fullPath", { enum: true, get: function () {
    {
      return "/" + this.service.mountPoint + this.path;
    }
  } });
HttpResource.prototype.status = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._dfltStatus || (this.parent ? this.parent.status() : this.service.status());
    } else {
      this._dfltStatus = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.num);rslt = this;
    }
  }return rslt;
};
HttpResource.prototype.contentType = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._dfltContentType || (this.parent ? this.parent.contentType() : this.service.contentType());
    } else {
      this._dfltContentType = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.text);rslt = this;
    }
  }return rslt;
};