"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const HttpFile = _dogmalang.dogma.use(require("./HttpFile"));const HttpFolder = _dogmalang.dogma.use(require("./HttpFolder"));
const $HttpService = class HttpService extends _justows.Service {
  constructor(srv, mPoint, opts, props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("opts", opts, { sync: { type: _dogmalang.bool, mandatory: true } }, true);super(srv, mPoint, opts, props);{
      _dogmalang.dogma.update(this, { name: "dfltContentType", visib: ":", assign: "=", value: props != null ? props.contentType : null }, { name: "dfltStatus", visib: ":", assign: "=", value: props != null ? props.status : null });if (!this._routes) {
        Object.defineProperty(this, "_routes", { value: {} });
      }
    }
  }
};
const HttpService = new Proxy($HttpService, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'HttpService' is abstract.";
  } });module.exports = exports = HttpService;
HttpService.prototype.search = function (path) {
  let rsc; /* istanbul ignore next */_dogmalang.dogma.paramExpected("path", path, _dogmalang.text);{
    for (let [route, val] of Object.entries(this._routes)) {
      {
        if (_dogmalang.dogma.like(path, route)) {
          rsc = val;break;
        }
      }
    }
  }return rsc;
};
HttpService.prototype._createFile = function (par, name, props) {
  let rsc; /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, null);{
    this._pvt_309ed390abd53af0bf2dfb21b98ca663_insertResource(rsc = HttpFile(this, par, name, props));
  }return rsc;
};
HttpService.prototype._createFolder = function (par, name, props) {
  let rsc; /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, null);{
    this._pvt_309ed390abd53af0bf2dfb21b98ca663_insertResource(rsc = HttpFolder(this, par, name, props));
  }return rsc;
};
HttpService.prototype._pvt_309ed390abd53af0bf2dfb21b98ca663_insertResource = function (rsc) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("rsc", rsc, null);{
    if (!this._routes) {
      Object.defineProperty(this, "_routes", { value: {} });
    }_dogmalang.dogma.setItem("=", this._routes, rsc.route, rsc);
  }
};
HttpService.prototype.status = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._dfltStatus;
    } else {
      this._dfltStatus = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.num);rslt = this;
    }
  }return rslt;
};
HttpService.prototype.contentType = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._dfltContentType;
    } else {
      this._dfltContentType = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.text);rslt = this;
    }
  }return rslt;
};