"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const WebQAuth = _dogmalang.dogma.use(require("./WebQAuth"));
const $WebQService = class WebQService extends _justows.Service {
  constructor(srv, mPoint, opts, props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("opts", opts, { sync: { type: _dogmalang.bool, mandatory: true } }, true); /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, null);super(srv, mPoint, opts, props);{
      /*istanbul ignore if*/if (!this._auths) {
        _dogmalang.dogma.update(this, { name: "auths", visib: ":", assign: ":=", value: {} });
      }
    }
  }
};
const WebQService = new Proxy($WebQService, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'WebQService' is abstract.";
  } });module.exports = exports = WebQService;
WebQService.prototype.search = function (q) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("q", q, _dogmalang.text);{
    return _dogmalang.dogma.getItem(this._auths, q);
  }
};
WebQService.prototype._createFile = function (par, name, props) {
  let auth; /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    auth = WebQAuth(this, par, name, props);if (!this._auths) {
      _dogmalang.dogma.update(this, { name: "auths", visib: ":", assign: ":=", value: {} });
    }_dogmalang.dogma.setItem("=", this._auths, auth.q, auth);
  }return auth;
};