"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const HttpResource = _dogmalang.dogma.use(require("./HttpResource"));
const $HttpFile = class HttpFile extends _justows.File {
  constructor(svc, par, name, props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, null);super(svc, par, name, getProps(props, name)); /* istanbul ignore next */if (HttpResource.prototype._constructor instanceof Function) HttpResource.prototype._constructor.bind(this)(getProps(props, name));{
      _dogmalang.dogma.update(_dogmalang.dogma.update(this, { name: "params", visib: ".", assign: ":=", value: getParamsOf(this) }), { name: "parameterized", visib: ".", assign: ":=", value: (0, _dogmalang.len)(this.params) > 0 });
    }
  }
};_dogmalang.dogma.mixin($HttpFile, HttpResource);
const HttpFile = new Proxy($HttpFile, { apply(receiver, self, args) {
    return new $HttpFile(...args);
  } });module.exports = exports = HttpFile;
function getParamsOf(file) {
  let params = []; /* istanbul ignore next */_dogmalang.dogma.paramExpected("file", file, HttpFile);{
    const PARAM = RegExp("/&([^/:]+)(:([^/:]+))?", "g");for (let p = PARAM.exec(file.path); p; p = PARAM.exec(file.path)) {
      p = { ["name"]: _dogmalang.dogma.getItem(p, 1), ["type"]: _dogmalang.dogma.getItem(p, 3) || "text" };if (!_dogmalang.dogma.includes(["text", "bool", "num"], p.type)) {
        _dogmalang.dogma.raise("invalid param type: %s.", p.type);
      }_dogmalang.dogma.lshift(params, p);
    }
  }return params;
}
Object.defineProperty(HttpFile.prototype, "route", { enum: true, get: function () {
    {
      return "^" + this.path.replace(RegExp("/&[^/]+", "g"), "/([^/]+)") + "$";
    }
  } });
function getProps(props, name) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, [_dogmalang.text, _dogmalang.func, _dogmalang.list, _dogmalang.map]); /* istanbul ignore next */_dogmalang.dogma.paramExpected("name", name, _dogmalang.text);{
    if (_dogmalang.dogma.is(props, [_dogmalang.text, _dogmalang.func, _dogmalang.list])) {
      props = { ["actions"]: { ["GET"]: props } };
    }if ((0, _dogmalang.keys)(props).some(item => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("item", item, null);{
        return _dogmalang.dogma.includes(["DELETE", "GET", "HEAD", "PATCH", "POST", "PUT"], item);
      }
    })) {
      props = { ["actions"]: props };
    }
  }return props;
}