"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const $HttpServer = class HttpServer extends _justows.ServiceServer {
  constructor(sSrv, opts, props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("opts", opts, { sync: { type: _dogmalang.bool, mandatory: true } }, true);super(sSrv, "HTTP Server", opts, props);{
      _dogmalang.dogma.update(this, { name: "mountPoint", visib: ".", assign: ":=", value: props != null ? props.mountPoint : null });
    }
  }
};
const HttpServer = new Proxy($HttpServer, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'HttpServer' is abstract.";
  } });module.exports = exports = HttpServer;
HttpServer.prototype._getPathOf = function (path) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("path", path, _dogmalang.text);{
    if (this.mountPoint) {
      const pattern = (0, _dogmalang.fmt)("^/%s/?", this.mountPoint);if (_dogmalang.dogma.notLike(path, pattern)) {
        return null;
      }path = path.replace(RegExp(pattern), "/");
    }
  }return path;
};