"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const PubCmd = _dogmalang.dogma.use(require("./PubCmd"));const SubCmd = _dogmalang.dogma.use(require("./SubCmd"));const UnsubCmd = _dogmalang.dogma.use(require("./UnsubCmd"));
const $WebQServer = class WebQServer extends _justows.ServiceServer {
  constructor(sSrv, opts, props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("opts", opts, { sync: { type: _dogmalang.bool, mandatory: true } }, true);super(sSrv, "WebQ Server", opts, props);{}
  }
};
const WebQServer = new Proxy($WebQServer, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'WebQServer' is abstract.";
  } });module.exports = exports = WebQServer;
WebQServer.prototype._buildCmd = function (msg) {
  let cmd; /* istanbul ignore next */_dogmalang.dogma.paramExpected("msg", msg, _dogmalang.map);{
    {
      const _ = msg.type;switch (_) {case "pub":
          {
            cmd = PubCmd(msg);
          }; /* istanbul ignore next */break;case "sub":
          {
            cmd = SubCmd(msg);
          }; /* istanbul ignore next */break;case "unsub":
          {
            cmd = UnsubCmd(msg);
          }; /* istanbul ignore next */break;default:
          {
            _dogmalang.dogma.raise("invalid command: %s.", _);
          }}
    }
  }return cmd;
};